# -*- coding: utf-8 -*-

from Model.Except import NotImplementedMethodeError

class Point(object):
    def __init__(self, name:str = "", profile=None, status = None):
        super(Point, self).__init__()

        self._status = status

        self._name = name
        self._profile = profile
        self._sl = None


    @property
    def sl(self):
        if self._sl is None:
            return self._profile.sl

        return self._sl

    @sl.setter
    def sl(self, sl):
        if sl == self._profile.sl:
            self._sl = None

        self._sl = sl

    @property
    def name(self):
        return self._name

    @name.setter
    def name(self, name):
        self._name = name
        self._status.modified()

    def point_is_named(self):
        """
        Returns:
            True if the point is named.
        """
        return self._name.strip() != ""

    def is_nan(self):
        raise NotImplementedMethodeError(self, self.is_nan)

    def dist(self, p2):
        raise NotImplementedMethodeError(self, self.dist)
