# -*- coding: utf-8 -*-

import time

from PyQt5.QtCore import (
    Qt, QObject, pyqtSlot, pyqtSignal
)

class Worker(QObject):
    signalStatus = pyqtSignal(str)

    def __init__(self, study, checker_list, parent=None):
        super(self.__class__, self).__init__(parent)

        self._study = study
        self._checker_list = checker_list

    def process(self):
        self.signalStatus.emit('start')
        self._compute()
        self.signalStatus.emit('end')

    def _compute(self):
        for checker in self._checker_list:
            self.signalStatus.emit(checker.name)

            # time.sleep(1)
            checker.run(self._study)

            self.signalStatus.emit("progress")
