# -*- coding: utf-8 -*-

from PyQt5.QtCore import QCoreApplication

from Model.LateralContribution.LateralContributionTypes import (
    NotDefined, LateralContrib, Rain, Evaporation,
)

_translate = QCoreApplication.translate

long_types = {
    "ND": _translate("LateralContribution", "Not defined"),
    "LC": _translate("LateralContribution", "Lateral contribution"),
    "RA": _translate("LateralContribution", "Rain"),
    "EV": _translate("LateralContribution", "Evaporation"),
}

table_headers = {
    "name": _translate("LateralContribution", "Name"),
    "type": _translate("LateralContribution", "Type"),
    "edge": _translate("LateralContribution", "Reach"),
    "begin_kp": _translate("LateralContribution", "Begin kp (m)"),
    "end_kp": _translate("LateralContribution", "End kp (m)")
}

LC_types = {
    "ND": NotDefined,
    "LC": LateralContrib,
    "RA": Rain,
    "EV": Evaporation,
}
